/*****************************************************
This program was produced by the
CodeWizardAVR V2.03.4 Standard
Automatic Program Generator
 Copyright 1998-2008 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Project :   
Version :  4.0
Date    : 11.05.2012
Author  : 
Company : 
Comments: 


Chip type           : ATmega32
Program type        : Application
Clock frequency     : 4,000000 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 512
*****************************************************/

#include <mega32.h>

// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x1B ;PORTA
#endasm
#include <lcd.h> 
#include <stdio.h>
#include  <sleep.h>

// AD1955
#define SS1 PORTD.1
#define MOSI PORTD.2
#define SCK PORTD.0

// WM8804
#define SS2 DDRC.0                 
#define MOSI_WM DDRB.7
#define MISO_WM PINC.1
#define SCK_WM DDRB.5
#define reset_WM DDRB.0




// 
#define MENU PINC.5 
#define NEXT PINC.2
#define PREV PINC.4
#define RETURN PINC.3

//  
#define usb {DDRD.4=0; DDRD.5=1; DDRD.6=0;}
#define caoxial {DDRD.4=0; DDRD.5=0; DDRD.6=1;}
#define toslink {DDRD.4=1; DDRD.5=0; DDRD.6=0;}

#define zummer PORTB.3
#define mute_relay PORTD.7
#define in_scan PINB.6

//  
#define enable_mcu PORTC.6 
#define toslink_out DDRC.7

#define LED PORTA.3

#define MUTE PORTB.2
#define LED_STATUS PORTB.4

#include <delay.h>
bit flags_button=1;
bit flags_avto=1; 
bit flags=1;
 
unsigned char data_width=1;

unsigned char timer_select=0;
unsigned char timer_search=0;
unsigned int timer_delay_eep=403;


unsigned char s_data_format=0;

unsigned char timer_mute_dis=0;
unsigned char sample_rate=0;
unsigned char de_emphasis=0;

volatile unsigned char timer_delay_read=0;
volatile unsigned char timer_sck=0; 
 

volatile unsigned char menu=0;
volatile unsigned char select_line=0;
volatile unsigned char mclk_=1;

volatile unsigned char data_spi1=0;

volatile unsigned char data_spi=0b00001100;;
volatile unsigned char mclk_data_spi=0b01000000; //    
volatile unsigned int freg=0;
unsigned char buffer [33];

unsigned char out_format=0;
unsigned char timer=0; //  reset  
unsigned char coaxial_enable=0;
unsigned char toslink_enable=0;


   unsigned char flags_sample_rate=1;
   unsigned char flags_sample_rate1=1;
   unsigned char flags_sample_rate2=1;
   unsigned char flags_sample_rate3=1; 
   
   unsigned char flags_scan_update=0; //     SCAN  
   
   unsigned int timer_off_led=0;

unsigned char button_active=1; //        






bit mute_on=0;

eeprom unsigned char eep_sign=0; //    .

eeprom unsigned char eep [1023];
           
volatile unsigned char timer_eep_butt, timer_eep_butt1, load_eep=0;
unsigned int read=0;

bit flags_eep=0;

bit  reset_settings=0;
bit flags_lcd=0;
bit reset_system=0; //   
bit mute_act=0;
bit flags_reset=1;
bit flags_clear=1;
bit flags_lcd1=0;

bit hi_end_mode=0;
volatile unsigned char timer_sleep=0;

unsigned char miso=0; //    SPI

unsigned char timer_mute=0;
unsigned char data_mclk_WM=0b00000110;
unsigned char data_width_WM=0b01000010;
unsigned char flags_eeprom=0; //  spdif     
unsigned char timer_volume_on=0;
unsigned char timer_volume_on1=0;
volatile unsigned char volume=100;
volatile unsigned int volume_AD=16383;
unsigned char flags_scan_=1;
unsigned int cnt_data=0;
unsigned int eep_cnt=0; //  
unsigned char timer_sleep_enable=0;

bit flags_zummer=1;
bit zummer_enable=1;
bit volume_enable=0;
unsigned char FLAGS_VOLUME=0; //       .

unsigned char flags_button_up1=1;

unsigned char timer_avto_on=0;
unsigned char timer_avto_on1=0;
unsigned char y=0;

unsigned char mode_WM_enable = 0b0; //  Master/Slave WM8804
 
             unsigned char timer_vol_plus=0; // timer   
             unsigned int w; //       
             unsigned char min_off=10;
             unsigned char select_mode_led=1;
             unsigned char time_off=10;
             unsigned char time=0;
             unsigned char sek=0;
             unsigned char min=0; 
             unsigned char flags_enab=1; 
             unsigned char flags_led_active=1; //        HI-END MODE
             unsigned char mode_SR=0; //   
             unsigned int SR=75; //     
             
 interrupt [EXT_INT1] void ext_int1_isr() 
 { 

  sleep_disable(); 
  
  
   
    
     timer_sleep=0;
     enable_mcu=1;     
     //************************************************************//
			 
			 flags_enab=1; //    
             min=sek=time=0; //   
			 
     //************************************************************//
            LED=1;

     timer_delay_read=TCCR1B=TCNT1=timer_sck=0;
    
 }
 
 void eep_load()
 { 
  
 
      //     
           if (eep_sign == 0x22)
             {    
               LED_STATUS=1;
               delay_ms(100);
               LED_STATUS=0;
               delay_ms(100);
               LED_STATUS=1;
               delay_ms(100);
               LED_STATUS=0; 
               
               if (w !=997)
               {
                for (w=0;w<997;w++) //     
                 { 
                   if(eep[w] == 0x25)
                   
                    {
                      eep_cnt=w; w=997; 
                      //if(eep_cnt>=1)eep[eep_cnt-1]=0;
                    }

                 };
               }    //       

                 
                
                cnt_data = eep[1+eep_cnt];
                data_spi = eep[2+eep_cnt];
                data_spi1 = eep[3+eep_cnt];
                mclk_data_spi = eep[4+eep_cnt];
                
                mclk_ = eep[5+eep_cnt];
                data_width = eep[6+eep_cnt];
                s_data_format = eep[7+eep_cnt];
                de_emphasis = eep[8+eep_cnt];
                sample_rate = eep[9+eep_cnt];
                flags_sample_rate = eep[10+eep_cnt];
                out_format = eep[11+eep_cnt];
                flags_avto = eep[12+eep_cnt];
                
                zummer_enable = eep[13+eep_cnt]; //       
                hi_end_mode = eep[14+eep_cnt]; 
                
                
                data_mclk_WM = eep[15+eep_cnt];
                data_width_WM = eep[16+eep_cnt];
                
                volume = eep[17+eep_cnt];
                
               
              
                
                flags_eeprom = eep[18+eep_cnt];
                select_mode_led = eep[19+eep_cnt]; 
                
                mode_WM_enable = eep[20+eep_cnt];
                
                SR = eep[21+eep_cnt]; 
                
                 
             } 
              else
             { 
              data_spi=0b00001100;
              data_spi1=0;
              mclk_data_spi=0b01000000;;
              
              mclk_ = 1;
              data_width = 1;
              s_data_format = 0;
              de_emphasis = 0;
              sample_rate = 0;
              out_format = 0;
              flags_avto = 0; 
              
              data_mclk_WM = 0b00000110;
              data_width_WM = 0b01000010;
              
              
               zummer_enable = 0;
                hi_end_mode = 0;
                flags_eeprom=0;
                
                volume = 100;
                
                select_mode_led=4;
                flags_sample_rate=1; 
                
                mode_WM_enable = 0b0; 
                SR=75;  
                
                lcd_gotoxy(0,0);
                lcd_putsf("  Warning!");
                lcd_gotoxy(0,1);
                lcd_putsf(" Eeprom Error");
                delay_ms(2000);
             } 
 
 }
 
 
 void eep_save()
 {
            
   
            //      
             if (flags_eep)
              {
              
            
                if (++timer_delay_eep > 400 && timer_delay_eep <402)
                {  
                 LED_STATUS=1;
                 delay_ms(100);
                 LED_STATUS=0;
                 delay_ms(100);
                 LED_STATUS=1;
                 delay_ms(100);
                 LED_STATUS=0;
                 
                 for(w=0;w<1023;w++) //   
                 {
                  eep[w]=0xFF;
                 }
                 //=====================//   
                 if(cnt_data<997) cnt_data++;
                 else cnt_data = 1;
                 //=====================//
                 eep_cnt = cnt_data;
                   
                 eep_sign = 0x22;
                 eep[eep_cnt] = 0x25; //    
                 eep[1+eep_cnt] = cnt_data;
                 eep[2+eep_cnt] = data_spi;
                 eep[3+eep_cnt] = data_spi1;
                 eep[4+eep_cnt] = mclk_data_spi;
                  



                 eep[5+eep_cnt] = mclk_;
                 eep[6+eep_cnt] = data_width;
                 eep[7+eep_cnt] = s_data_format;
                 eep[8+eep_cnt] = de_emphasis;
                 eep[9+eep_cnt] = sample_rate;
                 eep[10+eep_cnt] = flags_sample_rate;
                 eep[11+eep_cnt] = out_format;
                 eep[12+eep_cnt] = flags_avto;  


                 eep[13+eep_cnt] = zummer_enable; 
                 eep[14+eep_cnt] = hi_end_mode;
                  
                 eep[15+eep_cnt] = data_mclk_WM;
                 eep[16+eep_cnt] = data_width_WM;  
                

                 eep[17+eep_cnt] = volume;
                 
                 
                  eep[18+eep_cnt] = flags_eeprom;  //       
                 
                  
                  eep[19+eep_cnt]=select_mode_led;
                  
                  
                  eep[20+eep_cnt] = mode_WM_enable; //      S/M Mode WM8804     
                  
                  eep[21+eep_cnt] = SR;   
                  
                  //////////////////////
                  flags_eep=0;  
                  timer_delay_eep=403;
                  ////////////////////// 
                  
                }
              }  
              
     
    
 }
 
 
 


 
 
 
 void SPI_VOL(unsigned int Data1, unsigned char adr1)
{  
 LED_STATUS=1;   
 SS1=0;
 delay_us(100); 
 
  
  
  for (y=0;y<14;y++)
  {
    if (Data1 & 0x2000) MOSI=1;;
    else MOSI=0;
    SCK=0; 
    
    delay_us(100);
    SCK=1;
     
    delay_us(100);
    Data1<<=1;
  }

  for (y=0;y<2;y++)
  {
    if (adr1 & 0b10) MOSI=1;;
    else MOSI=0;
    SCK=0; 
     
    delay_us(100);
    SCK=1;       
     
    delay_us(100);
    adr1<<=1;
  }
  delay_us(100);
  SS1=1;
  delay_us(100);
  SCK=0;
  LED_STATUS=0;
}  


void SPI_WM8804(char PotNum,char Data)    
 { 
  
  
  char mask=0x80;
  
  LED_STATUS=1;
  
    //  8   ()      
  SCK_WM=1;
  delay_us(200);
  SS2=1; //   
  delay_us(200);

  for (y=0;y<8;y++)
   {
    MOSI_WM = (!(PotNum & 0b10000000));
    
    SCK_WM=1;
    
    
    
    delay_us(200);
    SCK_WM=0;
     
    delay_us(200);

    PotNum <<=1;      
    
    
     
   } 
   
    
   
   //Cnt=8; //  8    
   //     /

  for (y=0;y<8;y++)
   {     


    // 

    MOSI_WM = (!(Data & 0b10000000));
     
    SCK_WM=1;
    
    if (MISO_WM) miso |= mask;
    
    delay_us(200); 
    SCK_WM=0;
    
    delay_us(200);            

    Data <<=1; //    1   
    mask <<=1;

    
   }
   
    
   
   SCK_WM=1; 
   delay_us(200);  
    SS2=0;
   delay_us(200);  
    MOSI_WM=0;   
    LED_STATUS=0;
    delay_us(200);
 }
 


void SPI_AD(char Data)    
 {
   LED_STATUS=1;

   //  8   ()      

  SS1=0; //   
  delay_us(250);

  for (y=0;y<8;y++)
   {
    MOSI=Data & 0b10000000;
    SCK=0;
    
    delay_us(100);
    SCK=1;
    
    delay_us(100);

    Data <<=1;      

     
   } 
   
   SCK=0;
   LED_STATUS=0; 
 }
 
  

void SPI_MCLK(char Data,char PotNum)    
 {
  LED_STATUS=1;

   //  10   ()      

  SS1=0; //   
  delay_us(100);

  for (y=0;y<8;y++)
   {
    MOSI=Data & 0b10000000;
    SCK=0;
    
    delay_us(100);
    SCK=1;
    
    delay_us(100);

    Data <<=1;      

    
   }

   // Cnt=2; //  2  

   for (y=0;y<2;y++)
   {     
   

    // 

    MOSI=PotNum & 0b10;
    SCK=0;
     
    delay_us(100);
    SCK=1;  
   
    delay_us(100);            

    PotNum <<=1; //    1 

    
   }           

   SCK=0;
   delay_us(100);
   SS1=1;
   LED_STATUS=0;
 }  

 
 void volume_control_menu()  //   
 {   
    if (button_active==1)
     {

       
       
       //===============================================================================//
        
       
        if (PREV == 0 && NEXT)
         {
          timer_volume_on++;
          if (timer_volume_on < 10 && timer_volume_on1 < 10) timer_volume_on1=0;
          timer_sleep=0;
         }
         
         if (PREV && NEXT == 0)
         {
          timer_volume_on1++;
          if (timer_volume_on1 < 10 && timer_volume_on < 10) timer_volume_on=0;
          timer_sleep=0;
         } 
         
       if (timer_volume_on < 11 && timer_volume_on1 < 11)
        {    
           if ((PREV == 0 && NEXT == 0) && (timer_volume_on<8 && timer_volume_on!=0))   //    
               { 
                 select_line--;   
                 timer_sleep=0;   

                 
                 flags_button=0;       
                 timer_volume_on=timer_volume_on1=0;
                 
               }
           if ((PREV == 0 && NEXT == 0) && (timer_volume_on1<8 && timer_volume_on1!=0)) 
               {                                    
                 select_line++;    
                 timer_sleep=0;   

                 
                 flags_button=0;
                 timer_volume_on=timer_volume_on1=0;    
               }
        }    
         
         if ((timer_volume_on!=0) && timer_volume_on < 11 && NEXT==0 && PREV==0) { lcd_clear(); timer_volume_on = 0; }
         if (timer_volume_on > 10 && (NEXT || PREV)) timer_volume_on = 50; 
         if ((timer_volume_on1!=0) && timer_volume_on1 < 11 && NEXT==0 && PREV==0) { lcd_clear(); timer_volume_on1 = 0; }
         if (timer_volume_on1 > 10 && (NEXT || PREV)) timer_volume_on1 = 50;
          
           
         
         if (timer_volume_on > 10 || timer_volume_on1 > 10)
          {              
              flags_eep=1;         //   
              timer_delay_eep=0;   //   
              
              SPI_VOL(volume_AD,0b10);
              SPI_VOL(volume_AD,0b11);

              sprintf(buffer,"VOLUME %3d", volume);  //   
              lcd_gotoxy(1,1);
              lcd_puts(buffer);
              lcd_gotoxy(11,1);
              lcd_putsf("%   ");
              
              if (timer_volume_on > 1)timer_volume_on--;
              if (timer_volume_on1 > 1)timer_volume_on1--; 
              
                if (PREV == 0 && NEXT == 0 )
                 {
                  timer_vol_plus=0;
                   
                 }
               
               if (PREV && NEXT==0 )
               { 
                    
                 
                 if (timer_vol_plus==0)
                   {
                     if ((volume!=0) && (volume < 250))
                       {
                        volume-=5;
                        
                       }
                        else 
                       {
                        volume=0;
                         
                       }
                       
                       
                   }    
                      
                      timer_vol_plus++;  
                      
                      
                 if (timer_vol_plus>5)
                  {
                     if ((volume!=0) && (volume < 250))
                       {
                        volume-=5;
                         
                       }
                        else 
                       {
                        volume=0;
                         
                       } 
                       
                       timer_vol_plus=11;
                  }
                   
                  
               }
               
               if (PREV==0 && NEXT )
               { 
                    
                 
                 if (timer_vol_plus==0)
                   {
                      if (volume < 99) 
                       {
                        volume+=5;
                         
                       } 
                        else 
                       {
                        volume=100;
                         
                       }
                       
                       
                   }    
                      
                      timer_vol_plus++;  
                      
                      
                 if (timer_vol_plus>5)
                  {
                     if (volume < 99) 
                       {
                        volume+=5;
                         
                       } 
                        else 
                       {
                        volume=100;
                         
                       }
                       
                       timer_vol_plus=11;
                  }
                   
                  
               }
          }
       
          
          
       //===============================================================================//   

     }
 }   
 
 
 void menu_active() //       
{ 



//************************************************************************// 
 
 if(volume_AD > 16383 || volume == 100)   //    
             {
              volume_AD=16383;
             }
             
       if (volume<100 && volume!=0)
              {
               volume_AD = volume * 164;
              }  
              
              
       if (volume > 100)volume=100;
        
       if(volume == 0) {volume_AD=0;}
       
       
     
          
 //***********************************************************************//







 //         
  
 if (button_active==1) 
   {
       if (MENU==1 && flags_button==1)   //     1
       { 
         
        timer_sleep=0;
       if (++timer_avto_on1 > 15 )
        {
          flags_lcd1=1;
          menu=1;
         flags_button=0; 
         timer_avto_on1=0;
        } 
        
       }
       
       if (MENU == 0 && (timer_avto_on1!=0))   //   MUTE
       { 
           if (mute_on) mute_on=0;
           else mute_on=1;
         flags=1;
         
         timer_avto_on1=0; 
         flags_button=0;
          if ((timer_volume_on!=0) || (timer_volume_on1!=0))
           {
             timer_volume_on=timer_volume_on1=0; //     
             lcd_clear();
           }
       } 
   }
 
  if (flags_eeprom & (1<<0)) //   
  { 

   
    volume_control_menu();
    volume_enable=1;
    
  } else
  {
    volume_enable=0;
  } 
  
  
  if (flags_eeprom & (1<<2))  // / 
  {
     
    coaxial_enable=1;
    
  } else
  {
     
    coaxial_enable=0;
  }
  
  
  if (flags_eeprom & (1<<1))  // / 
  {
    toslink_out=1;
    toslink_enable=1;
    
  } else
  {
    toslink_out=0; 
    toslink_enable=0;
  }

   
  
  //      
 if (button_active==1)
   {
      if (NEXT==1 && flags_button==1 && PREV==0 && ((flags_eeprom & (1<<0))==0)) //   
      {
        select_line++;    //  ,      
        timer_sleep=0;    //    
        flags_button=0;   //    ,    ,    Volume_control()
      }
      
      if (PREV==1 && flags_button==1 && NEXT==0 && ((flags_eeprom & (1<<0))==0)) //   
      {
       select_line--; 
       timer_sleep=0; 
       flags_button=0;
      }
   }  
  
  //    
  
  switch (select_line)
  {
   case 0: 
   {
    caoxial;
    
    lcd_gotoxy(0,0);
    lcd_putsf("COAXIAL ");
   } break;
   
   case 1:
   {
    toslink;
    
    lcd_gotoxy(0,0);
    lcd_putsf("OPTICAL ");
   } break;

   case 2:
   {
    usb;
    
    lcd_gotoxy(0,0);
    lcd_putsf("  USB   ");
   } break;
  }
  
  if (SR>200)
      SR=10; 
               
  if (SR<10)
      SR=10;
  
  
  if (select_line > 2 && select_line < 4) select_line = 0;  //         
  if (select_line > 3) select_line = 2; 
  
  if (button_active==1)
   {
      if (RETURN==1 && flags_button==1)   //     avto / hwr
       {
         timer_sleep=0;
       if (++timer_avto_on > 15 )
        {
         if (flags_avto) flags_avto=0;
         else flags_avto=1;
         flags_button=0;
         flags_eep=1; 
         timer_avto_on=0;
        }
       }
       
       if (RETURN == 0 && (timer_avto_on!=0))   //      .
       {
         menu=17;
         timer_avto_on=0;
         timer_sleep=0; 
         flags_button=0;
       } 
   }   
   
   
   
    if (in_scan==0 && flags_avto==0)
         {    
          lcd_gotoxy(8,0);
          lcd_putsf(" AUTO   ");
          
          timer_search=timer_select=0;
         }
        
        if (in_scan==1 && flags_avto==0)
         { 
           flags_enab=1; //    
           min=sek=time=0; //   
           timer_sleep=0;
           timer_sleep_enable=0;
          if (timer_search > 14)
             {
               lcd_gotoxy(8,0);
               lcd_putsf(" SCAN    ");
             }
          
          if (++timer_search > 18)
           {

            if (++timer_select > 8)
             {
              select_line++;
              timer_select=0;
             }
             timer_search=19;
           }
         }
   
   
    if (timer_sleep < 250)
     {
  
        if ((timer_volume_on < 13) && (timer_volume_on1 < 13))
       {
            if (in_scan==0)
            {              
             
             if (flags_lcd)
              {
               lcd_clear();
               flags_lcd=0;
              }

             if(mute_on==0) // 
             {
               
              if ((!(mclk_data_spi & (1<<6))) && (!(mclk_data_spi & (1<<7)))) //     Fs
              {
               lcd_gotoxy(9,1);
               lcd_putsf("256Fs  ");
              } 
              if ((mclk_data_spi & (1<<6)) && (!(mclk_data_spi & (1<<7))))
              {

               lcd_gotoxy(9,1);
               lcd_putsf("512Fs  ");
              } 
              
             }
             else
             { 
              MUTE=1;
              timer_mute_dis=31;
              lcd_gotoxy(9,1);
              lcd_putsf("Mute   ");  

             } 
             
             if (flags_scan_update) //    SCAN
              {
               flags_scan_=1; 
               flags_scan_update=0;
              }
             
            }
             else 
            {       
             lcd_gotoxy(0,1);
             lcd_putsf("   NO SIGNAL    ");
             flags_lcd=1; //     lcd      
             flags_sample_rate1=1;
             flags_sample_rate2=1;
             flags_sample_rate3=1; 
             
			 
			 //************************************************************//
			 
			 flags_enab=1; //    
             min=sek=time=0; //   
			 
			 //************************************************************//
             
              //        
              
             flags_scan_=0;
             timer_delay_read=0;
             timer_sck=0;
             freg=0;
             TCCR1B=0;
             TCNT1=0; 
             
             flags_scan_update=1; //    SCAN
            }
       } 
        
       
         
        if (flags_avto==1)
         {
          lcd_gotoxy(8,0);
          lcd_putsf("  HWM   ");
          
          timer_search=timer_select=0;
         }

     //     
      if ((timer_volume_on < 13) && (timer_volume_on1 < 13))
      {    
          if(timer_delay_read < 10 && flags_scan_)
          {
           lcd_gotoxy(0,1);
           lcd_putsf(" SCAN    ");
		   
		   //**************************************************//
		   
		   flags_enab=1; //    
           min=sek=time=0; //   
		   
		   //**************************************************//
           
           flags_scan_=0;
          }
      
       
         if (++timer_delay_read > 10)
         {
           if (timer_sck==0) TCCR1B=7;    
                                              
           if (++timer_sck > 3)
            {
             freg=TCNT1;
            
             
             if (in_scan == 0) //   
             {
            
              
              if (freg > 5999 && freg < 9000)   //32000
               {
                lcd_gotoxy(0,1);
                  lcd_putsf(" 32kHz   "); 
                  
                  if (flags_sample_rate)
                   {
                     data_spi1 = data_spi1 &~ (1<<0);
                     data_spi1 = data_spi1 &~ (1<<1); // 48kHz 
                     if (flags_sample_rate1)
                       {
                         flags=1;
                         flags_sample_rate1=0;
                         flags_sample_rate2=1;
                         flags_sample_rate3=1;
                          
                       }
                   }
               }
              
              if (freg > 8999 && freg < 10350)   //44100
               {
                 lcd_gotoxy(0,1);
                  lcd_putsf(" 44.1kHz ");
                  
                  if (flags_sample_rate)
                   {
                     data_spi1 = data_spi1 &~ (1<<0);
                     data_spi1 = data_spi1 &~ (1<<1); // 48kHz   
                      if (flags_sample_rate1)
                       {
                         flags=1;
                         flags_sample_rate1=0;
                         flags_sample_rate2=1;
                         flags_sample_rate3=1; 
                         
                       }
                   }
               
               }
               
               if (freg > 10349 && freg < 16500) //48000
               {
                 lcd_gotoxy(0,1);
                  lcd_putsf(" 48kHz   ");
                  
                  if (flags_sample_rate)
                   {
                     data_spi1 = data_spi1 &~ (1<<0);
                     data_spi1 = data_spi1 &~ (1<<1); // 48kHz
                      if (flags_sample_rate1)
                       {
                         flags=1;
                         flags_sample_rate1=0;
                         flags_sample_rate2=1;
                         flags_sample_rate3=1;
                         
                       }
                   }
               
               }
               
               if (freg > 16499 && freg < 21000)   //88200
               {
                 lcd_gotoxy(0,1);
                  lcd_putsf(" 88.2kHz ");
                  
                  if (flags_sample_rate)
                   {
                     data_spi1 = data_spi1 | (1<<0);
                     data_spi1 = data_spi1 &~ (1<<1); // 96kHz
                      if (flags_sample_rate2)
                       {
                         flags=1;
                         flags_sample_rate1=1;
                         flags_sample_rate2=0;
                         flags_sample_rate3=1; 
                         
                       }
                   }
               }
               
               if (freg > 20999 && freg < 28000) // 96000
               {
                  
                  lcd_gotoxy(0,1);
                  lcd_putsf(" 96kHz   ");
                  
                  if (flags_sample_rate)
                   {
                     data_spi1 = data_spi1 | (1<<0);
                     data_spi1 = data_spi1 &~ (1<<1); // 96kHz
                      if (flags_sample_rate2)
                       {
                         flags=1;
                         flags_sample_rate1=1;
                         flags_sample_rate2=0;
                         flags_sample_rate3=1;
                         
                       }
                   }
               
               }
               
               if (freg > 28000 && freg < 48000) // 192000
               {
                 lcd_gotoxy(0,1);
                  lcd_putsf(" 192kHz  ");
                  
                  if (flags_sample_rate)
                   {
                     data_spi1 = data_spi1 &~ (1<<0);
                     data_spi1 = data_spi1 | (1<<1); // 192kHz
                      if (flags_sample_rate3)
                       {
                         flags=1;
                         flags_sample_rate1=1;
                         flags_sample_rate2=1;
                         flags_sample_rate3=0; 
                          
                       }
                   }
               
               }
               
               
               
                if (freg < 6000)
               {
                 lcd_gotoxy(0,1);
                  lcd_putsf("< O.F.R  "); 
                  
                   flags_sample_rate1=1;
                   flags_sample_rate2=1;
                   flags_sample_rate3=1;
               } 
               
               
                if (freg > 48000)
               {
                 lcd_gotoxy(0,1);
                  lcd_putsf("> O.F.R  "); 
                  
                   flags_sample_rate1=1;
                   flags_sample_rate2=1;
                   flags_sample_rate3=1;
               }
               
             }
             TCNT1=0;   
             freg=0;  
             timer_sck=0;
             timer_delay_read=0;
            }
            
            if (timer_delay_read < 10)
             {
              TCNT1=0;   
              freg=0;
              TCCR1B=0;  
             }
            
         }
      } else {
               timer_delay_read=0;
      
             }
     }
         
  eep_save();
              
              

   if (hi_end_mode==1)    //    
   {

    
     if(++timer_sleep > 250)    //    HI-END MODE
     { 
      flags_led_active=0; 
      LED=1;  //  
      timer_sleep=251;
      flags_scan_=1; //      (  ) 
      timer_delay_read=0; //     ( )
      timer_sck=0;         //  
       
       lcd_gotoxy(0,1);
       lcd_putsf("  HI-END MODE   ");  
       
       if (++timer_sleep_enable > 200)       //     
        { 
         timer_sleep_enable=0;  
         timer_sleep=0; 
         button_active=0; //   ,         
         LED=0;  
         lcd_clear();
         flags_led_active=1; 
         enable_mcu=0; //  
         delay_ms(20);
         sleep_enable();
         powerdown();
        }
     } 

   }  
              
              
              
     
           reset_settings=0; //   RESET
           flags_reset=1; //     
}

//  1    "mclk"

void menu_mclk_mode()   //           MENU   
{

     if (flags_lcd1)
      {
       lcd_clear();
       flags_lcd1=0;
      }
 


 if (MENU==1 && flags_button==1) //        1     mclk    
  {                                          //    next  prev
    //     mclk
   if(mclk_==1) mclk_=0;
   else mclk_=1;
    flags_eep=1; 
   flags_button=0;
  }
  
  if (RETURN==1 && flags_button==1) //        1     mclk    
  {                                       
   menu=0; //      
     
   flags_button=0;
  }
  

  
 if (NEXT==1 && flags_button==1)
  {
   menu=2;
   flags_button=0;
  } 
  
  if (PREV==1 && flags_button==1)
  {
   menu=0;
   flags_button=0;
  }
  
  
  if (mclk_==0)  //  
  {
     
   
   data_mclk_WM = 0b00010110; //        
   
   mclk_data_spi= mclk_data_spi &~ (1<<6); // 256xFs
   mclk_data_spi= mclk_data_spi &~ (1<<7);
   

           
           lcd_gotoxy(0,1);
           lcd_putsf(" 256Fs          ");
         
  }
  
   if (mclk_==1) //  
  {
   
   
   data_mclk_WM = 0b00000110; //        
   
   mclk_data_spi= mclk_data_spi | (1<<6);  // 512xFs
   mclk_data_spi= mclk_data_spi &~ (1<<7);
   
           lcd_gotoxy(0,1);
           lcd_putsf(" 512Fs ");
       
  }
  
    
    lcd_gotoxy(0,0);
    lcd_putsf(" MCLK MODE      ");
  
}

//  2    

void menu_data_width()
 { //  = 2

  if (MENU==1 && flags_button==1) //        1     mclk    
  {                                          //    next  prev 
     //     data
     data_width++;
    if(data_width > 2) data_width=0;
    
    flags_eep=1;
    flags_button=0;
  }
  
  if (RETURN==1 && flags_button==1) //     
  {                                         
   menu=0;  //    data   
   flags_button=0;
  }
  
 
   if (PREV==1 && flags_button==1)
  {
    menu=1;
   flags_button=0;
  }
  
 if (NEXT==1 && flags_button==1)  //    
  {
    menu=3;
    flags_button=0;
  } 
  
  
  
  if (data_width==0) //  24
  {
    
   
   data_width_WM = data_width_WM | (1<<2); //            
   data_width_WM = data_width_WM | (1<<3);
   
    data_spi = data_spi &~ (1<<2);
    data_spi = data_spi &~ (1<<3); // 24bit
    
    
    lcd_gotoxy(0,1);
    lcd_putsf(" 24bit          ");
    
  }
  
  if (data_width==1) //  16
  {
  
   
   data_width_WM = data_width_WM &~ (1<<2); //            
   data_width_WM = data_width_WM &~ (1<<3);
   
    data_spi = data_spi | (1<<2);
    data_spi = data_spi | (1<<3); // 16bit
    
    
    lcd_gotoxy(0,1);
    lcd_putsf(" 16bit          ");
    
  } 
  
  
   if (data_width==2) //  20
  {
  
   
   data_width_WM = data_width_WM | (1<<2); //            
   data_width_WM = data_width_WM &~ (1<<3);
   
    data_spi = data_spi | (1<<2);
    data_spi = data_spi &~ (1<<3); // 16bit
    
    
    lcd_gotoxy(0,1);
    lcd_putsf(" 20bit          ");
    
  }
  
   
    
    lcd_gotoxy(0,0);
    lcd_putsf(" DATA WIDTH     ");
   
 }

void menu_serial_data_format()
{
   if (MENU==1 && flags_button==1) //        1     mclk    
  {                                          //    next  prev 
   s_data_format++; //     data
    if (s_data_format>2) s_data_format=0;
    flags_eep=1; 
   flags_button=0;
  }
  
  if (RETURN==1 && flags_button==1) //     
  {                                         
   menu=0;  //    data   
   flags_button=0;
  }
  
 
   if (PREV==1 && flags_button==1)
  {
    menu=2;
   flags_button=0;
  }
  
 if (NEXT==1 && flags_button==1)  //    
  {
    menu=4;
    flags_button=0;
  } 
  
  
  
   if (s_data_format==0) // I2C
  {
   
   
    data_spi = data_spi &~ (1<<4);
    data_spi = data_spi &~ (1<<5); // I2C
      
    
   data_width_WM = data_width_WM | (1<<1); //            
   data_width_WM = data_width_WM &~ (1<<0);
    
    
    lcd_gotoxy(0,1);
    lcd_putsf(" I2C            ");
     
  } 
  
   if (s_data_format==1) // RJ
  {
   
   
    data_spi = data_spi | (1<<4);
    data_spi = data_spi &~ (1<<5); 
    
      
    
    data_width_WM = data_width_WM &~ (1<<1); //            
    data_width_WM = data_width_WM &~ (1<<0);
    
    
    lcd_gotoxy(0,1);
    lcd_putsf(" RJ             ");
     
  }
  
  
  if (s_data_format==2) // LJ
  {
   
   
    data_spi = data_spi | (1<<4);
    data_spi = data_spi | (1<<5); 
    
     
    
    data_width_WM = data_width_WM &~ (1<<1); //            
    data_width_WM = data_width_WM | (1<<0);
    
    lcd_gotoxy(0,1);
    lcd_putsf(" LJ             ");
    
  }
   
    
    lcd_gotoxy(0,0);
    lcd_putsf(" SERIAL D.F.    ");
}

void menu_de_emphasis()  //menu4
{

   if (MENU==1 && flags_button==1) //        1     mclk    
  {                                          //    next  prev 
   de_emphasis++; //     data
    if(de_emphasis>3) de_emphasis=0; 
    flags_eep=1;
   flags_button=0;
  }
  
  if (RETURN==1 && flags_button==1) //     
  {                                         
   menu=0;  //    data   
   flags_button=0;
  }
  
 
   if (PREV==1 && flags_button==1)
  {
    menu=3;
   flags_button=0;
  }
  
 if (NEXT==1 && flags_button==1)  //    
  {
    menu=5;
    flags_button=0;
  }  
  
  
   if (de_emphasis==0)  
  {
   
   
    data_spi = data_spi &~ (1<<6);
    data_spi = data_spi &~ (1<<7); // None

    
    lcd_gotoxy(0,1);
    lcd_putsf(" None           ");
    
  }  
  
   if (de_emphasis==1)  
  {
   
   
    data_spi = data_spi | (1<<6);
    data_spi = data_spi &~ (1<<7); // 44.1kHz

    
    lcd_gotoxy(0,1);
    lcd_putsf(" 44.1kHz        ");
    
  }
  
   if (de_emphasis==2)  
  {
   
   
    data_spi = data_spi &~ (1<<6);
    data_spi = data_spi | (1<<7); // 32kHz
     
    
    lcd_gotoxy(0,1);
    lcd_putsf(" 32kHz          ");
    
  }
  
   if (de_emphasis==3)  
  {
   
   
    data_spi = data_spi | (1<<6);
    data_spi = data_spi | (1<<7); // 48kHz
    
    lcd_gotoxy(0,1);
    lcd_putsf(" 48kHz          ");
     
  }

    
    lcd_gotoxy(0,0);
    lcd_putsf("DE EMPHASIS     ");

}

void menu_pcm_sample_rate() // menu5
{

     if (MENU==1 && flags_button==1) //        1     mclk    
  {                                          //    next  prev 
   sample_rate++; //     data
    if(sample_rate>3) sample_rate=0; 
    flags_eep=1;
   flags_button=0;
  }
  
  if (RETURN==1 && flags_button==1) //     
  {                                         
   menu=0;  //    data   
   flags_button=0;
  }
  
 
   if (PREV==1 && flags_button==1)
  {
    menu=4;
   flags_button=0;
  }
  
 if (NEXT==1 && flags_button==1)  //    
  {
    menu=6;
    flags_button=0;
  } 
                                //   
  
   if (sample_rate==0) 
  {
   
   
    data_spi1 = data_spi1 &~ (1<<0);
    data_spi1 = data_spi1 &~ (1<<1); // 48kHz

    
    lcd_gotoxy(0,1);
    lcd_putsf(" 48kHz          ");
     
  } 
  
   if (sample_rate==1)  
  {
   
   
    data_spi1 = data_spi1 | (1<<0);
    data_spi1 = data_spi1 &~ (1<<1); // 96kHz

    
    lcd_gotoxy(0,1);
    lcd_putsf(" 96kHz          ");
     
  } 
  
  if (sample_rate==2)  
  {
   
   
    data_spi1 = data_spi1 &~ (1<<0);
    data_spi1 = data_spi1 | (1<<1); // 192kHz
    
    lcd_gotoxy(0,1);
    lcd_putsf(" 192kHz         ");
    
  }


    if (sample_rate==3)
  {
    flags_sample_rate=1;
    flags_sample_rate1=1;
    flags_sample_rate2=1;
    flags_sample_rate3=1;
    
    lcd_gotoxy(0,1);
    lcd_putsf(" AUTO DETECT    ");
  }else
  {
    flags_sample_rate=0;
  }

    
    lcd_gotoxy(0,0);
    lcd_putsf(" PCM SAMPLE RATE");

}

void menu_out_format()   //menu6
{

    if (MENU==1 && flags_button==1) //        1     mclk    
  {                                          //    next  prev 
   out_format++; //     data
    if(out_format>2) out_format=0; 
    flags_eep=1;
   flags_button=0;
  }
  
  if (RETURN==1 && flags_button==1) //     
  {                                         
   menu=0;  //    data   
   flags_button=0;
  }
  
 
   if (PREV==1 && flags_button==1)
  {
    menu=5;
   flags_button=0;
  }
  
 if (NEXT==1 && flags_button==1)  //    
  {
    menu=7;
    flags_button=0;
  }
  
  if (out_format==0)  
  {
   
   
    data_spi1 = data_spi1 &~ (1<<2);
    data_spi1 = data_spi1 &~ (1<<3); // Stereo 
    
    lcd_gotoxy(0,1);
    lcd_putsf(" Stereo         ");
    
  }  
  
  if (out_format==1)  
  {
   
   
    data_spi1 = data_spi1 &~ (1<<2);
    data_spi1 = data_spi1 | (1<<3); // Mono left
    
    lcd_gotoxy(0,1);
    lcd_putsf(" Mono L         ");
     
  }
  
  if (out_format==2)  
  {
   
   
    data_spi1 = data_spi1 | (1<<2);
    data_spi1 = data_spi1 | (1<<3); // Mono Right
    
    lcd_gotoxy(0,1);
    lcd_putsf(" Mono R         ");
    
  }  
    
    lcd_gotoxy(0,0);
    lcd_putsf("AUDIO FORMAT    ");

}


void menu_reset()   //menu7
{

    if (MENU==1 && flags_button==1) //        1     mclk    
  {                                          //    next  prev 
   
     reset_settings=1; 
   
  }
  
  if (RETURN==1 && flags_button==1) //     
  {                                         
   menu=0;  //    data   
   flags_button=0;
   reset_settings=0;
  }
  
 
   if (PREV==1 && flags_button==1)
  {
    menu=6;
   flags_button=0;
   reset_settings=0;
  }
  
 if (NEXT==1 && flags_button==1)  //    
  {
    menu=8;
    flags_button=0; 
    reset_settings=0;
  }
  
  if (reset_settings==0)  
  {
    
    lcd_gotoxy(0,1);
    lcd_putsf(" RESET OFF      ");
    
  }  
  
  if (reset_settings==1)  
  { 
       
    
    data_spi1=0;
    mclk_data_spi=0;
    mclk_ = 1;
    data_width =1;
    s_data_format =0;
    de_emphasis =0;
    sample_rate =0;
    out_format =0;
    flags_avto =0;
    data_mclk_WM=0b00000110;
    data_width_WM=0b01000010; 
    data_spi=0b00001100;
    mclk_data_spi=0b01000000; //     

    
    lcd_gotoxy(0,1);
    lcd_putsf(" RESETING OK    ");
    
    
   
     
  }
  
  
    
    lcd_gotoxy(0,0);
    lcd_putsf(" RESET SETTING  ");

}




void menu_mute_system ()   //menu8
 {

    if (MENU==1 && flags_button==1) //        1     mclk    
  {                                          //    next  prev 
   
     if (mute_act) mute_act=0;
     else mute_act=1; 
     flags_eep=1;
     flags_button=0;
     
  }
  
  if (RETURN==1 && flags_button==1) //     
  {                                         
   menu=0;  //    data   
   flags_button=0;
  }
  

   if (PREV==1 && flags_button==1)
  {
    menu=7;
   flags_button=0;
  }
  
 if (NEXT==1 && flags_button==1)  //    
  {
    menu=9;
    flags_button=0;
  }
  
  if (mute_act==0)  
  { 
     
    data_spi1= data_spi1 &~ (1<<6);

    
     lcd_gotoxy(0,1);
    lcd_putsf(" MUTE DISABLE   ");
    
  }  
  
  if (mute_act==1)  
  {

    data_spi1= data_spi1 | (1<<6);
    

    
    lcd_gotoxy(0,1);
    lcd_putsf(" MUTE ENABLE    ");
   
     
  }

    
    lcd_gotoxy(0,0);
    lcd_putsf(" MUTE AUDIO     ");

 }
 
 
 
 void menu_version_system ()   //menu9
{

    if (MENU==1 && flags_button==1) //        1     mclk    
  {  
    lcd_gotoxy(0,0);
    lcd_putsf(" 10.05.2012\xb4.   ");                                        //    next  prev 
    
    lcd_gotoxy(0,1);
    lcd_putsf("a\xb3\xbf.\xa9\xb4p\xb8\xbco\xb3 A.A.");
   
  }
  
  if (RETURN==1 && flags_button==1) //     
  {                                         
   menu=0;  //    data   
   flags_button=0;
  }
  
 
   if (PREV==1 && flags_button==1)
  {
    menu=8;
   flags_button=0;
  }
  
 if (NEXT==1 && flags_button==1)  //    
  {
    menu=10;
    flags_button=0;
  }
  

    
      
    
   if (MENU==0)
   { 
    lcd_gotoxy(0,0);
    lcd_putsf(" VERSION SYSTEM "); 
    
    lcd_gotoxy(0,1);
    lcd_putsf("REV.System 4.0SP");
   }

}


void menu_reset_system () // menu 10
 {



  if (MENU==1 && flags_button==1) //        1     mclk    
  {                                          //    next  prev 
   
     reset_system=1; 
   
  }
  
  if (RETURN==1 && flags_button==1) //     
  {                                         
   menu=0;  //    data  
   timer=0;  //   
   
   flags_button=0;
  }
  

   if (PREV==1 && flags_button==1)
  {
    menu=9;
    timer=0; //   
   
    flags_button=0;
  }
  
 if (NEXT==1 && flags_button==1)  //    
  {
    menu=11;
    timer=0; //   
    
    flags_button=0;
  }
  
  if (reset_system==0 && flags_reset)  
  {

    sprintf(buffer,"RESET NONE ACT  ");
    lcd_gotoxy(0,1);
    lcd_puts(buffer);
    
  } 
  
    if (reset_system==0 && flags_reset==0)
    {
      lcd_gotoxy(0,1);
      lcd_putsf(" RESET COMPLITE ");
    } 
  
  if (reset_system==1)  
  {
   
    mute_relay = 0;
    
    if (timer > 3 && timer < 5)
     { 
       DDRB.7=0;
       reset_WM = 1;
       data_spi1= data_spi1 | (1<<7);
     }

    if (timer < 15) 
    {
     lcd_gotoxy(0,1);
     lcd_putsf(" RESET ACTIVE   ");
    }  
    
     if(++timer > 15 )
      {
        
         lcd_gotoxy(0,1);
         lcd_putsf(" RESET COMPLITE ");
        
        if (timer > 30)
        {
         data_spi1= data_spi1 &~ (1<<7);  
         reset_WM = 0; 
         delay_ms(25);  
         
               SPI_WM8804(0x1E,0b00000000); //  
        
               SPI_WM8804(0x1C,0b01000000); //   R28
               SPI_WM8804(0x1D,0b00010110); //   R29 
               
               SPI_WM8804(0x1B,data_width_WM);//      
               
               SPI_VOL(volume_AD,0b10);
               SPI_VOL(volume_AD,0b11);
         
         SPI_WM8804(0x07,data_mclk_WM); //       SPDIF
         delay_ms(1);
         SPI_WM8804(0x1B,data_width_WM);
         SPI_WM8804(0x1C,data_width_WM);
         delay_ms(1);
         SPI_WM8804(0x17,0b01110100); //         GPIO0
         delay_ms(1);
         
         SPI_AD(data_spi1);
         SPI_AD(data_spi);
         
         delay_us(100);
         SS1=1;
         delay_us(100);
         
           

         SPI_MCLK(mclk_data_spi,0b01);
         
         
         

         mute_relay = 1;
         timer=0;
         reset_system=0;
         flags_reset=0; //    "RESET NONE ACT" 
         
          lcd_gotoxy(0,1);
          lcd_putsf(" RESET COMPLITE ");
        }
      }

  }

    
    lcd_gotoxy(0,0);
    lcd_putsf(" SYSTEM RESET   ");

 }
 
 
 void menu_hi_end_mode()  // menu11
  {                      
    
   if (MENU==1 && flags_button==1) //        1     mclk    
   {                                          //    next  prev  
    if (hi_end_mode) hi_end_mode=0;
    else hi_end_mode=1; 
    flags_eep=1;  
    flags_button=0;
   }

   if (RETURN==1 && flags_button==1) //     
   {                                         
    menu=0;  //    data  
    timer=0;  //   

    flags_button=0;
   }


   if (PREV==1 && flags_button==1)
   {
    menu=10;
    timer=0; //   
    flags_button=0;
   }

   if (NEXT==1 && flags_button==1)  //    
   {
    menu=12;
    timer=0; //   
    
    flags_button=0;
   }

   if (hi_end_mode==0)  
   {

    
    lcd_gotoxy(0,1);
    lcd_putsf("HI-END MODE OFF "); 
    
   }  

   if (hi_end_mode==1)  
   {
    
    lcd_gotoxy(0,1);
    lcd_putsf("HI-END MODE ON  ");

   }    
    
    lcd_gotoxy(0,0);
    lcd_putsf("HI-END MODE     ");


  } 
  
  
  
  void menu_zummer_enable() //menu 12
  {
      
      if (MENU==1 && flags_button==1) //        1     mclk    
   {                                          //    next  prev  
    if (zummer_enable) zummer_enable=0;
    else zummer_enable=1; 
    flags_eep=1;  
    flags_button=0;
   }

   if (RETURN==1 && flags_button==1) //     
   {                                         
    menu=0;  //    data  
    timer=0;  //   

    flags_button=0;
   }


   if (PREV==1 && flags_button==1)
   {
    menu=11;
    timer=0; //   
    flags_button=0;
   }

   if (NEXT==1 && flags_button==1)  //    
   {
    menu=13;
    timer=0; //   
    
    flags_button=0;
   }

   if (zummer_enable==0)  
   {
    
    lcd_gotoxy(0,1);
    lcd_putsf("ZUMMER MODE OFF ");
    
   }  

   if (zummer_enable==1)  
   { 
    
    lcd_gotoxy(0,1);
    lcd_putsf("ZUMMER MODE ON  "); 

   }  

    
    lcd_gotoxy(0,0);
    lcd_putsf(" ZUMMER MODE    ");

  } 
  
  
  
  
   void menu_spdif_enable1() //menu 13
  {
      
      if (MENU==1 && flags_button==1) //        1     mclk    
   {                                          //    next  prev  
    if (coaxial_enable) coaxial_enable=0;
    else coaxial_enable=1; 
    flags_eep=1;  
    flags_button=0;
   }

   if (RETURN==1 && flags_button==1) //     
   {                                         
    menu=0;  //    data  
    timer=0;  //   

    flags_button=0;
   }


   if (PREV==1 && flags_button==1)
   {
    menu=12;
    timer=0; //   
    flags_button=0;
   }

   if (NEXT==1 && flags_button==1)  //    
   {
    menu=14;
    timer=0; //   
    
    flags_button=0;
   }

   if (coaxial_enable==0)  
   {
    
    lcd_gotoxy(0,1);
    lcd_putsf("COAXIAL DISABLE ");
    
    flags_eeprom = flags_eeprom &~ (1<<2);
    
   }  

   if (coaxial_enable==1)  
   { 
    
    lcd_gotoxy(0,1);
    lcd_putsf("COAXIAL ENABLE  "); 
    
    flags_eeprom = flags_eeprom | (1<<2);

   }  
   
    
    lcd_gotoxy(0,0);
    lcd_putsf("SPDIF OUT ENAB-1");  
    
    

  } 
  
  
     void menu_spdif_enable2() //menu 14
  {
      
      if (MENU==1 && flags_button==1) //        1     mclk    
   {                                          //    next  prev  
    if (toslink_enable) toslink_enable=0;
    else toslink_enable=1; 
    flags_eep=1;  
    flags_button=0;
   }

   if (RETURN==1 && flags_button==1) //     
   {                                         
    menu=0;  //    data  
    timer=0;  //   

    flags_button=0;
   }


   if (PREV==1 && flags_button==1)
   {
    menu=13;
    timer=0; //   
    flags_button=0;
   }

   if (NEXT==1 && flags_button==1)  //    
   {
    menu=15;
    timer=0; //   
    
    flags_button=0;
   }

   if (toslink_enable==0)  
   {
    
    lcd_gotoxy(0,1);
    lcd_putsf("TOSLINK DISABLE ");
    
    flags_eeprom = flags_eeprom &~ (1<<1);
    
   }  

   if (toslink_enable==1)  
   {
    
    lcd_gotoxy(0,1);
    lcd_putsf("TOSLINK ENABLE  "); 
    
    flags_eeprom = flags_eeprom | (1<<1);

   }  
   
    
    lcd_gotoxy(0,0);
    lcd_putsf("SPDIF OUT ENAB-2");

  }   
  
  void delay_off()
  {  
  
   if (++time > 13) 
       {
        sek++;
        time=0;
       }  //     
   if (sek > 59)
       {
        min++;
        sek=0;
       }
   if (min > 30)
       {
        min=sek=time=0;
       }  
       
       //***********************************************************// 
        
       //           
       
       if (in_scan)
       {
         if (++timer_off_led>1500)
          {
           LED=0;
           button_active=0; 
           flags_enab = min = time = sek = 0;
           timer_off_led=201;
          } 
       }
           else
          {
           if (timer_off_led!=0)timer_off_led=0;
          }
       
       //***********************************************************//
     
      if (flags_led_active) //   
       {  

          if(select_mode_led < 4 && (select_mode_led!=0)) //  
            {

              if((sek > time_off) && flags_enab)
              {
                LED=0;
                button_active=0; 
               flags_enab = min = time = sek = 0;
              }
              
             if((sek < time_off) && flags_enab)
              {
                LED=1;
              }  
            } else if (select_mode_led > 3 && (select_mode_led!=12)) //    
               {

                 if((min > min_off) && flags_enab)
                  {
                    LED=0;
                    button_active=0; 
                    flags_enab = min = time = sek = 0;
                  }
                  
                 if((min < min_off) && flags_enab)
                  {
                    LED=1;
                  } 
               } else if (select_mode_led==0)
                    {
                     LED=0;
                    } else if (select_mode_led==12) 
                        {
                          LED=1;
                        }  
       }
  } 
  
  void menu_led_control() // menu 15
   {
              if (MENU==1 && flags_button==1) //        1     mclk    
           {                                          //    next  prev  
            if (select_mode_led < 12) select_mode_led++;
            else select_mode_led=0; 
            flags_eep=1;
            flags_button=0;
           }

           if (RETURN==1 && flags_button==1) //     
           {                                         
            menu=0;  //    data  
            timer=0;  //   

            flags_button=0;
           }


           if (PREV==1 && flags_button==1)
           {
            menu=14;
            timer=0; //   
            flags_button=0;
           }

           if (NEXT==1 && flags_button==1)  //    
           {
            menu=16;
            timer=0; //   
            
            flags_button=0;
           }   
           
      

       switch (select_mode_led)
        { 
          case 0:
            lcd_gotoxy(0,1);
            lcd_putsf("LED OFF Enable  ");
            
            
          break;  
          case 1: 
            lcd_gotoxy(0,1);
            lcd_putsf("LED OFF 10S     "); 
            
            time_off=10;
           
            
          break; 
          case 2: 
            lcd_gotoxy(0,1);
            lcd_putsf("LED OFF 30S     ");
            
            time_off=30; 
           
            
          break;
          case 3: 
            lcd_gotoxy(0,1);
            lcd_putsf("LED OFF 60S     "); 
            
            time_off=58;
           
            
          break; 
          case 4: 
            lcd_gotoxy(0,1);
            lcd_putsf("LED OFF 2M      "); 
            
            min_off=2;
           
            
          break;
          case 5: 
            lcd_gotoxy(0,1);
            lcd_putsf("LED OFF 5M      ");
            
            min_off=5; 
          
             
          break;
          case 6: 
            lcd_gotoxy(0,1);
            lcd_putsf("LED OFF 7M      ");
            
            min_off=7;  
           
            
          break;
          case 7: 
            lcd_gotoxy(0,1);
            lcd_putsf("LED OFF 10M     "); 
            
            min_off=10;
          
            
          break; 
          case 8: 
            lcd_gotoxy(0,1);
            lcd_putsf("LED OFF 15M     "); 
            
            min_off=15;
          
            
          break;
          case 9: 
            lcd_gotoxy(0,1);
            lcd_putsf("LED OFF 20M     ");
            
            min_off=20;
           
            
          break;  
          case 10: 
            lcd_gotoxy(0,1);
            lcd_putsf("LED OFF 25M     ");  
            
            min_off=25;
           
            
          break;
          case 11: 
            lcd_gotoxy(0,1);
            lcd_putsf("LED OFF 30M     ");  
            
            min_off=30;
           
            
          break; 
           case 12: 
            lcd_gotoxy(0,1);
            lcd_putsf("LED OFF Disable ");
            
            min_off=0; 
           
           break;
           default: 
         }
    
    lcd_gotoxy(0,0);
    lcd_putsf("LED CONTROL OFF ");
   }    
   
            
  
  void volume_control()  // menu 16
  {
  
    if (MENU==1 && flags_button==1) //        1     mclk    
   {                                          //    next  prev  
    if (volume_enable) volume_enable=0;
    else volume_enable=1; 
    flags_eep=1;  
    flags_button=0;
     if (volume_enable==0)
     {
      FLAGS_VOLUME=1;
     }
   }

   if (RETURN==1 && flags_button==1) //     
   {                                         
    menu=0;  //    data  
    timer=0;  //   

    flags_button=0;
   }


   if (PREV==1 && flags_button==1)
   {
    menu=15;
    timer=0; //   
    flags_button=0;
   }

   if (NEXT==1 && flags_button==1)  //    
   {
    menu=17;
    timer=0; //   
    
    flags_button=0;
   }   
   


   if (volume_enable==0)  
   {

    lcd_gotoxy(0,1);
    lcd_putsf("VOLUME DISABLE  ");  
    
    
     volume=100;
     volume_AD = 16383;
       
       
     if (FLAGS_VOLUME) 
     { 
      SPI_VOL(volume_AD,0b10);
      SPI_VOL(volume_AD,0b11);
      
      FLAGS_VOLUME=0;;
     } 
    
    
    
    flags_eeprom = flags_eeprom &~ (1<<0);
    
   }  

   if (volume_enable==1)  
   {
    
    lcd_gotoxy(0,1);
    lcd_putsf("VOLUME ENABLE   ");
    
    flags_eeprom = flags_eeprom | (1<<0);  

   }  
   
    
    lcd_gotoxy(0,0);
    lcd_putsf("VOLUME CONTROL  ");
  }
  
  
  
  
  
   void mode_WM8804_control()  // menu 17
  {

    if (MENU==1 && flags_button==1) //        1     mclk    
   {                                          //    next  prev  
    if (mode_WM_enable) mode_WM_enable=0;
    else mode_WM_enable=1; 
    flags_eep=1;  
    flags_button=0;
    
   }

   if (RETURN==1 && flags_button==1) //     
   {                                         
    menu=0;  //    data  
    timer=0;  //   
    flags_button=0;
   }


   if (PREV==1 && flags_button==1)
   {
    menu=16;
    timer=0; //   
    flags_button=0;
   }

   if (NEXT==1 && flags_button==1)  //    
   {
      
    
    menu=18;
    
    timer=0; //    
    flags_button=0;
   }   
   


   if (mode_WM_enable==0)  
   {
   
    data_width_WM = data_width_WM | (1<<6);

    lcd_gotoxy(0,1);
    lcd_putsf("Master Mode     ");  
    
   }  

   if (mode_WM_enable==1)  
   { 
   
    data_width_WM = data_width_WM &~ (1<<6);
    
    lcd_gotoxy(0,1);
    lcd_putsf("Slave Mode      ");
 

   }  
   
    
    lcd_gotoxy(0,0);
    lcd_putsf("M/S Mode WM8804 ");
  } 
  
  
  
  
  
  void mode_calibration()  // menu 18
  { 
  ////////////////////////////////////////////////////////////////
  //////////////////////////////////////////////////////////////// 
  
      if (mode_SR==1) flags_eep=1;
    
       if (PREV==1 & flags_button==1 & mode_SR==1)   //     
       { 
        
          
        timer_volume_on++;
       if (timer_volume_on > 15 )
        { 
         
          if (SR>9) 
                  SR-=3;
               
              
           
         
         
          flags_lcd1=1;
         
         flags_button_up1=0; 
         timer_volume_on=13; 
          
         flags_eep=1;
         
         

        }
       }
        
       
       if ((PREV == 0) && (timer_volume_on!=0) && (flags_button_up1==1))   //    
       {
          
         
         
           if (mode_SR==1)
            {
               if (SR>9) 
                  SR--;
              
            } 
            
            
            

         timer_volume_on=0; 
         flags_button=0;       
         
         
       }  
       
      if (PREV==1 & flags_button==1 & mode_SR==0)
       {
                                             
           menu=17;
          mode_SR=0;
        flags_button=0;
       }

       if (NEXT==1 & flags_button==1 & mode_SR==0)  //    
       {
          lcd_clear();                       
           menu=19;
          mode_SR=0;
        flags_button=0;
       }            
       
       
       
      
       if (NEXT==1 & flags_button==1 & mode_SR==1)   //     
       { 
        
         
        timer_volume_on1++;
       if (timer_volume_on1 > 15 )
        { 
         if (SR<201)
          SR+=3;
               
              
           
          
          
          flags_lcd1=1;
         
         flags_button_up1=0; 
         timer_volume_on1=13; 
          flags_eep=1;
         
        }
       }
       
       if ((NEXT == 0) && (timer_volume_on1!=0) && (flags_button_up1==1))   //    
       { 
        
            
            if (mode_SR==1)
            {
               if (SR<201) 
                  SR++;
              
            } 
            
             if (mode_SR==0) 
            {                                       
               menu=19;
            }   

         timer_volume_on1=0; 
         flags_button=0;    
       }  
       
        if (SR>200)     //   
               SR=10; 
               
         if (SR<10)
               SR=200;
       
       
       
       if (NEXT==0 && PREV==0) 
       {  
         timer_volume_on1=timer_volume_on=0;
         if (flags_button_up1==0)
         {
           lcd_clear();
         }
         flags_button_up1=1;
       } 
   
  
  
  
  
  
  
  
  
  
  
  /////////////////////////////////////////////////////////////////
  /////////////////////////////////////////////////////////////////

    if (MENU==1 && flags_button==1) //        1     mclk    
   {                                          //    next  prev  
    if (mode_SR) mode_SR=0;
    else mode_SR=1; 
    //flags_eep=1;  
    flags_button=0;
    
   }

   if (RETURN==1 && flags_button==1) //     
   { 
    mode_SR=0;                                       
    menu=0;  //    data  
    timer=0;  //   
    flags_button=0;
   }



   


   if (mode_SR==0)  
   {

    lcd_gotoxy(0,0);
    lcd_putsf("*");
    
    lcd_gotoxy(0,1);
    lcd_putsf(" ");  
    
   }  

   if (mode_SR==1)  
   { 
    lcd_gotoxy(0,1);
    lcd_putsf("*"); 
    
    lcd_gotoxy(0,0);
    lcd_putsf(" ");

   }  
   
    
    lcd_gotoxy(1,0);
    lcd_putsf("Mode SR Correct");  
    
   
    
    
          sprintf(buffer,"%3d", SR);  //   
          lcd_gotoxy(11,1);
          lcd_puts(buffer);
          lcd_gotoxy(14,1);
          lcd_putsf("x "); 
          
            
    
    ////////////////////////////////////////////////////////////////////////
    ////////////////////////////////////////////////////////////////////////
        
    if (++timer_delay_read < 7)   //      
    {
      lcd_gotoxy(1,1);
      lcd_putsf(" SCAN     ");
    }
       
         if (++timer_delay_read > 10)
         {
           if (timer_sck==0) TCCR1B=7;  //    
         
           if (++timer_sck > 3) //  
            {
             freg=TCNT1;       //  
            
             


              
              if (freg > 5999 && freg < 9000)   //32000
               {
                lcd_gotoxy(1,1);
                  lcd_putsf(" 32kHz    "); 
                  
                  if (flags_sample_rate)
                   {
                     data_spi1 = data_spi1 &~ (1<<0);
                     data_spi1 = data_spi1 &~ (1<<1); // 48kHz 
                     if (flags_sample_rate1)
                       {
                         flags=1;
                         flags_sample_rate1=0;
                         flags_sample_rate2=1;
                         flags_sample_rate3=1;
                          
                       }
                   }
               }
              
              if (freg > 8999 && freg < 10350)   //44100
               {
                 lcd_gotoxy(1,1);
                  lcd_putsf(" 44.1kHz  ");
                  
                  if (flags_sample_rate)
                   {
                     data_spi1 = data_spi1 &~ (1<<0);
                     data_spi1 = data_spi1 &~ (1<<1); // 48kHz   
                      if (flags_sample_rate1)
                       {
                         flags=1;
                         flags_sample_rate1=0;
                         flags_sample_rate2=1;
                         flags_sample_rate3=1; 
                         
                       }
                   }
               
               }
               
               if (freg > 10349 && freg < 16500) //48000
               {
                 lcd_gotoxy(1,1);
                  lcd_putsf(" 48kHz    ");
                  
                  if (flags_sample_rate)
                   {
                     data_spi1 = data_spi1 &~ (1<<0);
                     data_spi1 = data_spi1 &~ (1<<1); // 48kHz
                      if (flags_sample_rate1)
                       {
                         flags=1;
                         flags_sample_rate1=0;
                         flags_sample_rate2=1;
                         flags_sample_rate3=1;
                         
                       }
                   }
               
               }
               
               if (freg > 16499 && freg < 21000)   //88200
               {
                 lcd_gotoxy(1,1);
                  lcd_putsf(" 88.2kHz  ");
                  
                  if (flags_sample_rate)
                   {
                     data_spi1 = data_spi1 | (1<<0);
                     data_spi1 = data_spi1 &~ (1<<1); // 96kHz
                      if (flags_sample_rate2)
                       {
                         flags=1;
                         flags_sample_rate1=1;
                         flags_sample_rate2=0;
                         flags_sample_rate3=1; 
                         
                       }
                   }
               }
               
               if (freg > 20999 && freg < 28000) // 96000
               {
                  
                  lcd_gotoxy(1,1);
                  lcd_putsf(" 96kHz    ");
                  
                  if (flags_sample_rate)
                   {
                     data_spi1 = data_spi1 | (1<<0);
                     data_spi1 = data_spi1 &~ (1<<1); // 96kHz
                      if (flags_sample_rate2)
                       {
                         flags=1;
                         flags_sample_rate1=1;
                         flags_sample_rate2=0;
                         flags_sample_rate3=1;
                         
                       }
                   }
               
               }
               
               if (freg > 28000 && freg < 48000) // 192000
               {
                 lcd_gotoxy(1,1);
                  lcd_putsf(" 192kHz   ");
                  
                  if (flags_sample_rate)
                   {
                     data_spi1 = data_spi1 &~ (1<<0);
                     data_spi1 = data_spi1 | (1<<1); // 192kHz
                      if (flags_sample_rate3)
                       {
                         flags=1;
                         flags_sample_rate1=1;
                         flags_sample_rate2=1;
                         flags_sample_rate3=0; 
                          
                       }
                   }
               
               }
               
               if (freg < 6000)
               {
                 lcd_gotoxy(1,1);
                  lcd_putsf(" O.F.R <  "); 
                  
                   flags_sample_rate1=1;
                   flags_sample_rate2=1;
                   flags_sample_rate3=1;
               } 
               
               
                if (freg > 48000)
               {
                 lcd_gotoxy(1,1);
                  lcd_putsf(" O.F.R >  "); 
                  
                   flags_sample_rate1=1;
                   flags_sample_rate2=1;
                   flags_sample_rate3=1;
               }
             
             TCNT1=0;   
             freg=0;  
             timer_sck=0;
             timer_delay_read=7;
            }
            
            if (timer_delay_read < 10)
             {
              TCNT1=0;   
              freg=0;
              TCCR1B=0;  
             }
            
         }
    
    ////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////// 
    
    
    
     
    
    
    
  }  
  
 void menu_eeprom() // menu19
 {
    lcd_gotoxy(1,0);
    lcd_putsf("Eeprom data    "); 
    if(load_eep==0) {lcd_clear();}
    
    if (++load_eep > 40)
    {
     read++;
          
          load_eep=1;
         
          
         
    } 
    
      if(read>1022)read=0; 
    
     sprintf(buffer,"%3Xh  ", eep[read]);  //   
          lcd_gotoxy(0,1);
          lcd_puts(buffer);
          
       sprintf(buffer,"%4db   ", read);  //   
          lcd_gotoxy(6,1);
          lcd_puts(buffer);  
    
    
    if (RETURN==1 && flags_button==1) //     
   {
    load_eep=read=0;                                        
    menu=0;  //    data  
    timer=0;  //   
    flags_button=0;
   }
   
   
   
   if (PREV==1 && flags_button==1)   //      18
       { 
          
          
       if (++timer_eep_butt > 15 )
        { 
        
           
          
          load_eep=read=0;
          menu=18;
         flags_button=0; 
         timer_eep_butt=0;
        }
       }
       
       if (PREV == 0 && (timer_eep_butt!=0))   //     
       { 
          read--; //      
          if (read>1022) read=1022;
          load_eep=1;
         
         
         timer_eep_butt=0; 
         flags_button=0;
       } 

  
   
   if (NEXT==1 && flags_button==1)   //      20
       { 
          
          
       if (++timer_eep_butt1 > 15 )
        {  
         
          load_eep=read=0;
          menu=20;
         flags_button=0; 
         timer_eep_butt1=0;
        }
       }
       
       if (NEXT == 0 && (timer_eep_butt1!=0))   //     
       { 
          read++; //   
          load_eep=1;
           
         
         timer_eep_butt1=0; 
         flags_button=0;
       } 
   
    
   
   if (MENU==1 && flags_button==1) //        1     mclk    
   {                                          //    next  prev  
    read=0;  
    flags_button=0;
    
   }  
    
    
 } 
 
/* void eeprom_life()
 {
    lcd_gotoxy(1,0);
    lcd_putsf("Eeprom life");
    
    
 } */


 void menu_end() // menu20
 {
     
    
    lcd_gotoxy(0,0);
    lcd_putsf("  MENU END        ");
       
    lcd_gotoxy(0,1);
    lcd_putsf(" EXIT MENU \x3E   ");
    
    delay_ms(1000);
    lcd_clear();
    menu=0;
    

 } 



void menu_shou()
{

        switch (menu)
       {
          case 0: menu_active(); break;
          case 1: menu_mclk_mode(); break;
          case 2: menu_data_width(); break;
          case 3: menu_serial_data_format(); break;
          case 4: menu_de_emphasis(); break;
          case 5: menu_pcm_sample_rate(); break;
          case 6: menu_out_format(); break;
          case 7: menu_reset(); break;
          case 8: menu_mute_system(); break;
          case 9: menu_version_system(); break;
          case 10: menu_reset_system(); break; 
          case 11: menu_hi_end_mode(); break;
          case 12: menu_zummer_enable(); break;
          case 13: menu_spdif_enable1(); break;
          case 14: menu_spdif_enable2(); break;
          case 15: menu_led_control(); break;   
          case 16:  volume_control(); break;
          case 17: mode_WM8804_control(); break;  
          case 18: mode_calibration(); break;
          case 19: menu_eeprom();break;
          case 20: menu_end(); break;  
        }

}




 void led_control()
{

   switch (select_mode_led)
        { 
          case 0:
           
          time_off=0;     //    
            
          break;  
          case 1: 
            
            time_off=10;
           
            
          break; 
          case 2: 
            
            time_off=30; 
           
            
          break;
          case 3: 
            
            time_off=58;
           
            
          break; 
          case 4: 
            
            min_off=2;  //   2 
           
            
          break;
          case 5: 
            
            min_off=5; 
          
             
          break;
          case 6: 
            
            min_off=7;  
           
            
          break;
          case 7: 
            
            min_off=10;
          
            
          break; 
          case 8: 
            
            min_off=15;
          
            
          break;
          case 9: 
            
            min_off=20;
           
            
          break;  
          case 10:  
            
            min_off=25;
           
            
          break;
          case 11: 
            
            min_off=30;
           
            
          break; 
           case 12: //    
            
            min_off=62; 
           
           break; 
         }
  //return select_mode_led;
}




// Declare your global variables here

void main(void)
{



// Declare your local variables here

// Input/Output Ports initialization
// Port A initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;

// Port B initialization
// Func7=Out Func6=Out Func5=Out Func4=In Func3=In Func2=In Func1=In Func0=out 
// State7=0 State6=0 State5=0 State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x1D;

// Port C initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=Out Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=0 State0=T 
PORTC=0x40;
DDRC=0x41;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=Out Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=P State2=0 State1=0 State0=0 
PORTD=0x08;
DDRD=0xF7;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
// Mode: Normal top=FFh
// OC0 output: Disconnected
TCCR0=0x00;
TCNT0=0x00;
OCR0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x00;
TCCR1B=0;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
// INT2: Off
MCUCR=0x00;
MCUCSR=0x00;
GICR=0x80;  // on interrupt int1

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;
DDRA.3=1;
LED=1;
MUTE=1;
 //    
LED_STATUS=1;
delay_ms(100);
LED_STATUS=0;
delay_ms(100);
LED_STATUS=1;
delay_ms(100);
LED_STATUS=0;
delay_ms(100);
LED_STATUS=1;
delay_ms(100);
LED_STATUS=0;

 

// LCD module initialization
lcd_init(16);

lcd_clear();

//   



eep_load();
   
menu_active(); //        
   
  
lcd_clear(); 
lcd_gotoxy(0,0);
lcd_putsf(" PRO AUDIO DAC  ");

lcd_gotoxy(0,1);
lcd_putsf("  LOADING  ");
delay_ms(500);

 lcd_gotoxy(0,1);
 lcd_putsf(" ----------  0%"); 
 
 SR*=8;        

 delay_ms(SR);

 lcd_gotoxy(1,1);
 lcd_putsf("\xFF");
 
 lcd_gotoxy(12,1);
 lcd_putsf("10%");
 
 SR/=8; 
 
 SR*=3;
  
 delay_ms(SR);
 
 lcd_gotoxy(2,1);
 lcd_putsf("\xFF");
 
  lcd_gotoxy(12,1);
 lcd_putsf("20%");
 
 delay_ms(SR); 
 
 lcd_gotoxy(3,1);
 lcd_putsf("\xFF");
 
  lcd_gotoxy(12,1);
 lcd_putsf("30%");
 

 delay_ms(SR); 
 
 lcd_gotoxy(4,1);
 lcd_putsf("\xFF");

 lcd_gotoxy(12,1);
 lcd_putsf("40%");
 
 delay_ms(SR); 
 
 lcd_gotoxy(5,1);
 lcd_putsf("\xFF");

 lcd_gotoxy(12,1);
 lcd_putsf("50%");

 delay_ms(SR); 
 
 lcd_gotoxy(6,1);
 lcd_putsf("\xFF");

 lcd_gotoxy(12,1);
 lcd_putsf("60%");

 delay_ms(SR);
 
 lcd_gotoxy(7,1);
 lcd_putsf("\xFF");

 lcd_gotoxy(12,1);
 lcd_putsf("70%");

 delay_ms(SR);
 
 lcd_gotoxy(8,1);
 lcd_putsf("\xFF");

 lcd_gotoxy(12,1);
 lcd_putsf("80%");

 delay_ms(SR);
 
 lcd_gotoxy(9,1);
 lcd_putsf("\xFF");

 lcd_gotoxy(12,1);
 lcd_putsf("90%");

 delay_ms(SR); 
 
 lcd_gotoxy(10,1);
 lcd_putsf("\xFF"); 
 
 lcd_gotoxy(12,1);
 lcd_putsf("100%");

 delay_ms(SR);


        
        
SS2=0;
reset_WM = 1; // reset down
SR/=3;

SR*=10;
                
delay_ms(SR);

SR/=10;

reset_WM = 0; // reset up

 
delay_ms(SR);

       SPI_WM8804(0x1E,0b00000000); //  
       SPI_WM8804(0x17,0b01110100); //         GPIO0
       SPI_WM8804(0x1C,0b01000010); //   R28
       SPI_WM8804(0x1D,0b10000110); //   R29
       
       SPI_VOL(volume_AD,0b10);
       SPI_VOL(volume_AD,0b11);  

//    R29  0x1D

// spdif 192kHz enable bit 7

// read enable status bit 3
// read enable bit 3=1;
// read disable bit 3=0;

// chanel status registr bit 2:0
//  000 default 
// 000 = interupt status register
// 001 = chanel status register 1
// 010 = chanel status register 2
// 011 = chanel status register 3
// 100 = chanel status register 4
// 101 = chanel status register 5
// 110 = spdif status register 

// 0x0B R11  
// 0x0C R12   bit 5 bit 4 -   

// 0x17   GPIO0   0100   SPDIF


lcd_clear();

flags=1;

#asm("sei")

MUTE=0;

led_control();



while (1)
      {
      // Place your code here 
            
            if (mute_on==0)
            {
              if (in_scan==0)  //     MUTE  
               {
                
                
                   if (timer_mute_dis < 33) //  
                   {
                    timer_mute_dis++;
                   }
                   
                    if ((timer_mute_dis > 31) && (timer_mute_dis < 33)) //          SPI
                   {
                    mute_relay=1; // UNmute 
                    MUTE=0;
                   }
                 
               } else
               {
                MUTE=1;
                mute_relay=0;    //     
                timer_mute_dis=0;  //  
                timer_mute=0; //     
               }
                  
               
            }
       
       

       if (flags)
        {  
         
         
         SPI_AD(data_spi1); //   
         SPI_AD(data_spi);  //   
         
         delay_us(100);
         SS1=1;
         delay_us(100);
         
           

         SPI_MCLK(mclk_data_spi,0b01);

          
         
         SPI_WM8804(0x07,data_mclk_WM); //       SPDIF
         
         SPI_WM8804(0x1B,data_width_WM);//      
         SPI_WM8804(0x1C,data_width_WM); //      spdif  

         
         flags=0;
        }
        
        
        if (timer_mute < 51) //   MUTE     
         {
          timer_mute++;
         }
        
        if (timer_mute > 47 && timer_mute < 50)
         {  
           mute_relay=1;
         }
        
        if ((menu!=0) && (menu!=18))  //      
        {
             flags_scan_=1;
             timer_delay_read=0;
             timer_sck=0;
             freg=0;
             TCCR1B=0;
             TCNT1=0;
             timer_volume_on=timer_volume_on1=0; //    
        }
        
    
        menu_shou();
        
        
        if (NEXT==0 && PREV==0 && MENU==0 && RETURN==0) //   
         {
          flags_button=1;
          flags_clear=1; 
           if (button_active==2) //        
            {
              button_active=1;
            }
         }
         
        if ( MENU && ((menu!=12) & (menu!=11) & (menu!=9) & (menu!=13) & (menu!=14)) )
         {
          flags=1;
          sleep_disable();
         }

          if ( MENU || RETURN || NEXT || PREV )
         { 
          if(flags_clear)
          {          
              flags_zummer=1;
              timer_delay_eep=0;
               flags_enab=1; //    
               min=sek=time=0; //   
              timer_sleep=0;
              timer_sleep_enable=0;
              flags_clear=0; 
                if (button_active==0) //        
                  {
                   button_active=2;
                  } 
          }
          
           if (SR<45) delay_ms(25);
              
               timer_delay_read=TCCR1B=TCNT1=timer_sck=0;
         }


        
        delay_off(); //   

        
        if (flags_zummer && zummer_enable)  //  
         { 
          LED_STATUS=1;
          zummer=1;
          delay_us(600);
          zummer=0;
          delay_us(600);
          zummer=1;
          delay_us(600);
          zummer=0;
          delay_us(600);
          zummer=1;
          delay_us(600);
          zummer=0;
          delay_us(600);
          zummer=1;
          delay_us(600);
          zummer=0;
          delay_us(600);
          zummer=1;
          delay_us(600);
          zummer=0;
          LED_STATUS=0;

          flags_zummer=0;
         }
         
       
        
         delay_ms(SR); 
         //delay_us(SR_PR) 

      };
}
